#!/perl/bin/perl
use Win32::OLE;
use DB_File;    # Access DB databases
use Fcntl;      # Needed for above...
use File::Find; # Directory searching
use strict;
undef $/; # Don't obey line boundaries
use vars qw( $stop_path $stop $currentKey %indexdb $dir);
my $databasename=$ARGV[0] or givehelp();
my $path=$ARGV[1];
$path=~ s|(\w+)$|$1/|;  #likes a trailing slash
if ($ARGV[2])  {
	my $stop=$ARGV[2];
	$stop=~ s/,/|/g;			#convert commas to pipes for stoplist;
	$stop_path=qr"$stop"io;
}
#  Stores file entries in index.db as <NULL><binary file number>
#  The leading NULL prevents any word entries from colliding.
unlink("$databasename.db");
tie(%indexdb,'DB_File',"$databasename.db",
    O_RDWR | O_CREAT, 0644, $DB_File::DB_BTREE) ;
find(\&IndexFile,$path);
untie(%indexdb); # release database

sub IndexFile {
    if(!-f) { return; }
	if (defined $stop_path)  {
		$dir=$File::Find::dir;
		return if $dir=~ m/$stop_path/o;
	}

    if(/\.html?$/) { # Handle HTML files
	print "$File::Find::name\n";
	open(HTML_FILE,$_);
	my($text) = <HTML_FILE>; # Read entire file
	$text =~ s/<[^>]*>//g; # Strip out all HTML tags
	# Index all the words under the current key
	my($wordsIndexed) = &IndexWords($text,$currentKey);
	# Map key to this filename
	$indexdb{pack"xn",$currentKey} = $File::Find::name;
	$currentKey++;
    }

    Win32::Sleep(100);  #this is purely to give the rest of the system a chance
						# the indexer can drag down Everything on a long run
}

###########################################################################

sub IndexWords {
    my($words, $fileKey) = @_;
    my(%worduniq); # for unique-ifying word list
    # Split text into Array of words
    my(@words) = split(/[^a-zA-Z0-9\xc0-\xff\+\/\_]+/, lc $words);
    @words = grep { $worduniq{$_}++ == 0 } # Remove duplicates
	     grep { s/^[^a-zA-Z0-9\xc0-\xff]+//; $_ } # Strip leading punct
             grep { length > 1 } # Must be longer than one character
             grep { /[a-zA-Z0-9\xc0-\xff]/ } # must have an alphanumeric
             @words;

    # For each word, add key to word database
    foreach (sort @words) {
	my($a) = $indexdb{$_};
	$a .= pack "n",$fileKey;
        $indexdb{$_} = $a;
    }

    # Return count of words indexed
    return scalar(@words);
}

sub givehelp  {
	print "index.pl Database_name /Path/ Comma,separatated,list,of,what,to,exclude";
	exit;
}

=head1 Indexdb

=head2 Description

	Given a directory, index all HTML documents recursively.
	Exclude a stop path list of regexs given in comma delimited form.

	You can have quite precise databases, this helps!!

	DB stuff Adapted from somewhere
	 (and I don't remember who it was so get your
		 credits in here!)

=head2 USAGE:
	perl indexdb.pl perl /perl html,site,lib,docs
	# get everything But the main docs

=head2 Author: Robert White  yzorderex@yahoo.com

=cut

